function car = importCarFile(filename, startRow, endRow)
%IMPORTFILE Import numeric data from a text file as a matrix.
%   CAR = IMPORTFILE(FILENAME) Reads data from text file FILENAME for the
%   default selection.
%
%   CAR = IMPORTFILE(FILENAME, STARTROW, ENDROW) Reads data from rows
%   STARTROW through ENDROW of text file FILENAME.
%
% Example:
%   car = importfile('Car1_191119_195839.csv', 2, 1468);
%
%    See also TEXTSCAN.

% Auto-generated by MATLAB on 2019/11/25 15:50:33

%% Initialize variables.
delimiter = '\t';
if nargin<=2
    startRow = 2;
    endRow = inf;
end

%% Format for each line of text:
%   column1: datetimes (%{yyyy-MM-dd HH:mm:ss.SSSSSS}D)
%	column2: double (%f)
%   column3: double (%f)
%	column4: double (%f)
%   column5: double (%f)
%	column6: double (%f)
%   column7: double (%f)
%	column8: double (%f)
%   column9: double (%f)
%	column10: double (%f)
%   column11: double (%f)
%	column12: double (%f)
%   column13: double (%f)
%	column14: double (%f)
%   column15: double (%f)
%	column16: double (%f)
%   column17: double (%f)
%	column18: double (%f)
%   column19: double (%f)
%	column20: double (%f)
%   column21: double (%f)
%	column22: double (%f)
%   column23: double (%f)
%	column24: double (%f)
%   column25: double (%f)
%	column26: double (%f)
%   column27: categorical (%C)
%	column28: categorical (%C)
%   column29: categorical (%C)
%	column30: categorical (%C)
%   column31: categorical (%C)
%	column32: categorical (%C)
%   column33: categorical (%C)
%	column34: categorical (%C)
%   column35: categorical (%C)
% For more information, see the TEXTSCAN documentation.
formatSpec = '%{yyyy-MM-dd HH:mm:ss.SSSSSS}D%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%C%C%C%C%C%C%C%C%C%[^\n\r]';

%% Open the text file.
fileID = fopen(filename,'r');

%% Read columns of data according to the format.
% This call is based on the structure of the file used to generate this
% code. If an error occurs for a different file, try regenerating the code
% from the Import Tool.
dataArray = textscan(fileID, formatSpec, endRow(1)-startRow(1)+1, 'Delimiter', delimiter, 'TextType', 'string', 'HeaderLines', startRow(1)-1, 'ReturnOnError', false, 'EndOfLine', '\r\n');
for block=2:length(startRow)
    frewind(fileID);
    dataArrayBlock = textscan(fileID, formatSpec, endRow(block)-startRow(block)+1, 'Delimiter', delimiter, 'TextType', 'string', 'HeaderLines', startRow(block)-1, 'ReturnOnError', false, 'EndOfLine', '\r\n');
    for col=1:length(dataArray)
        dataArray{col} = [dataArray{col};dataArrayBlock{col}];
    end
end

%% Close the text file.
fclose(fileID);

%% Post processing for unimportable data.
% No unimportable data rules were applied during the import, so no post
% processing code is included. To generate code which works for
% unimportable data, select unimportable cells in a file and regenerate the
% script.

%% Create output variable
car = table(dataArray{1:end-1}, 'VariableNames', {'datetime','lon','lat','height','hMSL','hAcc','vAcc','velN','velE','velD','gSpeed','headMot','sAcc','headAcc','refStationId','iTOW','relPosN','relPosE','relPosD','relPosLength','relPosHeading','accN','accE','accD','accLength','accHeading','gnssFixOK','diffSoln','relPosValid','carrSoln','isMoving','refPosMiss','refObsMiss','relPosHeadingValid','relPosNormalized'});

% For code requiring serial dates (datenum) instead of datetime, uncomment
% the following line(s) below to return the imported dates as datenum(s).

% car.datetime=datenum(car.datetime);

